var settings = new AlphaTab.Settings();
settings.Scale = 1;
settings.Width = 950;
settings.Height = 200;
settings.Engine = "default";
settings.Layout = AlphaTab.LayoutSettings.get_Defaults();
settings.Layout.AdditionalSettings['hideInfo'] = true;
settings.Staves = [];
settings.Staves.push(new AlphaTab.StaveSettings("marker"));
//settings.staves.Add(new StaveSettings("triplet-feel"));
settings.Staves.push(new AlphaTab.StaveSettings("tempo"));
settings.Staves.push(new AlphaTab.StaveSettings("text"));
settings.Staves.push(new AlphaTab.StaveSettings("chords"));
settings.Staves.push(new AlphaTab.StaveSettings("trill"));
settings.Staves.push(new AlphaTab.StaveSettings("beat-vibrato"));
settings.Staves.push(new AlphaTab.StaveSettings("note-vibrato"));
settings.Staves.push(new AlphaTab.StaveSettings("alternate-endings"));
//settings.Staves.push(new AlphaTab.StaveSettings("score"));
settings.Staves.push(new AlphaTab.StaveSettings("crescendo"));
settings.Staves.push(new AlphaTab.StaveSettings("dynamics"));
settings.Staves.push(new AlphaTab.StaveSettings("tap"));
settings.Staves.push(new AlphaTab.StaveSettings("fade-in"));
settings.Staves.push(new AlphaTab.StaveSettings("harmonics"));
settings.Staves.push(new AlphaTab.StaveSettings("let-ring"));
settings.Staves.push(new AlphaTab.StaveSettings("palm-mute"));
settings.Staves.push(new AlphaTab.StaveSettings("tab"));
settings.Staves.push(new AlphaTab.StaveSettings("pick-stroke"));
settings.Staves.push(new AlphaTab.StaveSettings("rhythm-up"));

// Annonymous function to inject modifications upon original alphaTab code, globally
(function () {
    // Add time-signature for tab bar
    AlphaTab.Rendering.TabBarRenderer.prototype.CreatePreBeatGlyphs = function (){
        if (this.Bar.get_MasterBar().IsRepeatStart){
            this.AddPreBeatGlyph(new AlphaTab.Rendering.Glyphs.RepeatOpenGlyph(0, 0, 1.5, 3));
        }
        // Clef
        //if (this.get_IsFirstOfLine()){
        //    this.AddPreBeatGlyph(new AlphaTab.Rendering.Glyphs.TabClefGlyph(0, 0));
        //}
        // XXX: Add time signature here
        if ((this.Bar.PreviousBar == null) || (this.Bar.PreviousBar != null && this.Bar.get_MasterBar().TimeSignatureNumerator != this.Bar.PreviousBar.get_MasterBar().TimeSignatureNumerator) || (this.Bar.PreviousBar != null && this.Bar.get_MasterBar().TimeSignatureDenominator != this.Bar.PreviousBar.get_MasterBar().TimeSignatureDenominator)){
            this.AddPreBeatGlyph(new AlphaTab.Rendering.Glyphs.SpacingGlyph(0, 0, 5 * this.get_Scale(), true));
            // XXX: for tunings where number of strings is less than 6
            var timeSignatureYOffset = (this.Bar.Track.Tuning.length - 4) * 5;
            this.AddPreBeatGlyph(new AlphaTab.Rendering.Glyphs.TimeSignatureGlyph(0, timeSignatureYOffset, this.Bar.get_MasterBar().TimeSignatureNumerator, this.Bar.get_MasterBar().TimeSignatureDenominator));
        }
        this.AddPreBeatGlyph(new AlphaTab.Rendering.Glyphs.BarNumberGlyph(0, this.GetTabY(-1, -3), this.Bar.Index + 1, !this.Stave.IsFirstInAccolade));
        if (this.Bar.get_IsEmpty()){
            this.AddPreBeatGlyph(new AlphaTab.Rendering.Glyphs.SpacingGlyph(0, 0, 30 * this.get_Scale(), false));
        }
    };
 
    // Disable drawing of accolade in stave group by hacking into its prototype
    
    AlphaTab.Rendering.Staves.StaveGroup.prototype.PaintPartial = function (cx, cy, canvas, startIndex, count){
        for (var i = 0,j = this._allStaves.length; i < j; i++){
            this._allStaves[i].Paint(cx, cy, canvas, startIndex, count);
        }
        var res = this.Layout.Renderer.RenderingResources;
        if (this.Staves.length > 0 && startIndex == 0){
            //
            // Draw start grouping
            //
            if (this._firstStaveInAccolade != null && this._lastStaveInAccolade != null){
                //
                // draw grouping line for all staves
                //
                var firstStart = cy + this._firstStaveInAccolade.Y + this._firstStaveInAccolade.StaveTop + this._firstStaveInAccolade.TopSpacing + this._firstStaveInAccolade.get_TopOverflow();
                var lastEnd = cy + this._lastStaveInAccolade.Y + this._lastStaveInAccolade.TopSpacing + this._lastStaveInAccolade.get_TopOverflow() + this._lastStaveInAccolade.StaveBottom;
                var acooladeX = cx + this._firstStaveInAccolade.X;
                canvas.set_Color(res.BarSeperatorColor);
                canvas.BeginPath();
                canvas.MoveTo(acooladeX, firstStart);
                canvas.LineTo(acooladeX, lastEnd);
                canvas.Stroke();
            };
        }
        canvas.set_Font(res.EffectFont);
        for (var i = 0,j = this.Staves.length; i < j; i++){
            var g = this.Staves[i];
            if (g.FirstStaveInAccolade != null && g.LastStaveInAccolade != null){
                var firstStart = cy + g.FirstStaveInAccolade.Y + g.FirstStaveInAccolade.StaveTop + g.FirstStaveInAccolade.TopSpacing + g.FirstStaveInAccolade.get_TopOverflow();
                var lastEnd = cy + g.LastStaveInAccolade.Y + g.LastStaveInAccolade.TopSpacing + g.LastStaveInAccolade.get_TopOverflow() + g.LastStaveInAccolade.StaveBottom;
                var acooladeX = cx + g.FirstStaveInAccolade.X;
                var barSize = (3 * this.Layout.Renderer.Settings.Scale);
                var barOffset = barSize;
                var accoladeStart = firstStart - (barSize * 4);
                var accoladeEnd = lastEnd + (barSize * 4);
                // text
                if (this.Index == 0){
                    canvas.FillText(g.Track.ShortName, cx + (10 * this.Layout.get_Scale()), firstStart);
                }
            }
        }
    };

})();

//function removeStandardNotation(settings) {
//    var staves = settings.Staves;
//    var filteredStaves = [];
//    for (i = 0; i < staves.length; i++) {
//        if (staves[i].Id !== "score") {
//            filteredStaves.push(staves[i]);
//        }
//    }
//    settings.Staves = filteredStaves;
//}
//removeStandardNotation(settings);
var currentScore = null;

/// Open a file using its bytes content
/// @param bytes  An array of bytes
/// @return array of tracks upon success, nil upon failure
function openFile(bytes) {
    try {
        AlphaTab.Rendering.Layout.PageViewLayout.PagePadding = new Float32Array([5, 0, 10, 0]);
        
        currentScore = AlphaTab.Importer.ScoreLoader.LoadScoreFromBytes(new Uint8Array(bytes));
        var renderer = $('#alphaTab').alphaTab('renderer');
        renderer.Layout.RenderAnnotation = function () {return; };
        activeTrackIndex = 0;
        renderer.Render(currentScore.Tracks[0]);
        return getTracks();
    }
    catch(e) {
        console.error(e);
        return null;
    }
}

function generateMidi() {
    // invalid score
    if(currentScore == null) {
        return null;
    }
    // Hot patch for AlaphTab.Audio.Generator.MidiFileGenerator,
    // adding a message for meta event FF 2F 00
    var p = AlphaTab.Audio.Generator.MidiFileGenerator.prototype;
    p.Generate = function (){
        // initialize tracks
        for (var i = 0,j = this._score.Tracks.length; i < j; i++){
            this.GenerateTrack(this._score.Tracks[i]);
        }
        var controller = new AlphaTab.Audio.Generator.MidiPlaybackController(this._score);
        var previousMasterBar = null;
        // store the previous played bar for repeats
        while (!controller.get_Finished()){
            var index = controller.Index;
            var bar = this._score.MasterBars[index];
            var currentTick = controller.CurrentTick;
            controller.ProcessCurrent();
            if (controller.ShouldPlay){
                this.GenerateMasterBar(bar, previousMasterBar, currentTick);
                for (var i = 0,j = this._score.Tracks.length; i < j; i++){
                    this.GenerateBar(this._score.Tracks[i].Bars[index], currentTick);
                }
            }
            controller.MoveNext();
            previousMasterBar = bar;
        }
        for (var i = 0,j = this._score.Tracks.length; i < j; i++){
            this._handler.AddEvent(i, controller.CurrentTick, AlphaTab.Audio.Generator.MidiFileHandler.BuildMetaMessage(0x2f, new Uint8Array([])));
        }
    };
    AlphaTab.Audio.Generator.MidiFileGenerator.prototype = p;
    
    var midi = AlphaTab.Audio.Generator.MidiFileGenerator.GenerateMidiFile(currentScore);
    var ms = new AlphaTab.IO.ByteBuffer();
    midi.WriteTo(ms);
    // XXX: ToArray() crashes WKWebView!
    var bytes = new Array();
    var buffer = ms.GetBuffer();
    var length = ms.get_Length();
    for (var i = 0; i< length; i++) {
        bytes[i] = buffer[i];
    }
    
//    var bytes = ms.ToArray();
    if (typeof android !== "undefined") {
        android.GetMidiFile(bytes);
    }
    return bytes;
}


function getTracks() {
    var tracks = currentScore.Tracks;
    var result = [];
    for (i = 0; i < tracks.length; i++) {
        var t = tracks[i];
        result.push({"name": t.Name, "is_percussion": t.IsPercussion, "program": t.PlaybackInfo.Program});
    }
    if (typeof android !== "undefined") {
        j = window.JSON.stringify(result);
        android.HtmlcallJava(j);
    }
    return result;
}
var activeTrackIndex = null;
function setActiveTrack(index) {
    //$.alphaTab.restore('#alphaTab');
    if (index >= 0 && index < currentScore.Tracks.length) {
        $('#alphaTab').alphaTab(settings);
        var renderer = $('#alphaTab').alphaTab('renderer');
        renderer.Layout.RenderAnnotation = function () {return; };
        activeTrackIndex = index;
        renderer.Render(currentScore.Tracks[index]);
    }
    if (typeof android !== "undefined") {
        android.LoadFinish();
    }
}

// Android Only!
function updateScale(scale) {
    
    settings.Scale = parseFloat(scale);
       
	$('#alphaTab').alphaTab('renderer').Invalidate();
	android.LoadFinish();
}

function getTickUpdateCache() {
    if (currentScore == null) {
        return null;
    } else {
        return AlphaTab.Audio.MidiUtils.BuildTickLookup(currentScore);
    }
}

function updateBoundingCache() {
    var renderer = $('#alphaTab').alphaTab('renderer');
    return renderer.BuildBoundingsLookup();
}

function playerCursorUpdateTick(tick) {
    if (cursorCache == null) {
        cursorCache = updateBoundingCache();
    }
    
    var tracks = currentScore.Tracks;
    if(tracks.length > 0) {
        var beat = getTickUpdateCache().FindBeat(tracks[activeTrackIndex], tick);
        playerCursorUpdateBeat(beat, cursorCache);
    }
}

var tempoChangesCache = null;
function GenerateTempoChangesCache(){
    tempoChangesCache = new Array();
    var bpm = 120;
    var division = 960;
    var previousMasterBar = null;
    var currentTime = 0;
    var controller = new AlphaTab.Audio.Generator.MidiPlaybackController(currentScore);
    var change = null;
    var previousChange = null;
    while (!controller.get_Finished()){
        var index = controller.Index;
        var bar = currentScore.MasterBars[index];
        var currentTick = controller.CurrentTick;
        controller.ProcessCurrent();
        if (controller.ShouldPlay){
            if (previousMasterBar == null){
                bpm = bar.Score.Tempo;
                change = [bpm, currentTick, currentTime];
            } else {
                if (bar.TempoAutomation != null){
                    bpm = bar.TempoAutomation.Value;
                    change = [bpm, currentTick, currentTime];
                }
            }
            if (change != null) {
                tempoChangesCache.push(change);
                previousChange = change;
            }
            currentTime += previousChange[2] + bar.CalculateDuration() * (60000 / (bpm * division));
            change = null;
        }
        controller.MoveNext();
        previousMasterBar = bar;
        
    }
}
function TicksToMillis(ticks){
    var time = 0;
    var bpm = 120;
    var division = 960;
    var lastChange = 0;
    if (tempoChangesCache == null) {
        GenerateTempoChangesCache();
    }

    // find start and bpm of last tempo change before time
    for (var i = 0; i < tempoChangesCache.length; i++){
        var c = tempoChangesCache[i];
        if (ticks < c[1]){
            break;
        }
        time = c[2];
        bpm = c[0];
        lastChange = c[2];
    }
    // add the missing millis
    ticks -= lastChange;
    time += ((ticks * (60000 / (bpm * division)))) | 0;
    return time;
}

function MillisToTicks(time){
    var bpm = 120;
    var division = 960; // from alphaTab: AlphaTab.Audio.Model.MidiFile.prototype
    // find start and bpm of last tempo change before time
    if (tempoChangesCache == null) {
        GenerateTempoChangesCache();
    }

    var ticks = 0;
    var lastChange = 0;
    //var time = 0;
    for (var i = 0; i < tempoChangesCache.length; i++){
//            var c = this._tempoChanges[i];
//            if (time < c.Time){
//                break;
//            }
//            ticks = c.Ticks;
//            bpm = c.Bpm;
//            lastChange = c.Time;
    

        var c = tempoChangesCache[i];
        if (time < c[2]){
            break;
        }
        ticks = c[1];
        bpm = c[0];
        lastChange = c[2];
    }
    // add the missing ticks
    time -= lastChange;
    ticks += ((time / (60000 / (bpm * division)))) | 0;
    return ticks;
}

var currentBeat = null;
var barCursor = null;
var beatCursor = null;
var lastScroll;
var scrollOffset= -30;
var scrollSpeed = 300;
function playerCursorUpdateBeat(beat, cache) {
    if(beat == null) return;
    currentBeat = beat;
    
    //var cursorWrapper = context.cursorOptions.cursors;
    //var barCursor = barCursor;
    //var beatCursor = beatCursor;
    
    var barBoundings = cache.Bars[beat.Voice.Bar.Index];
    var beatBoundings = barBoundings.Beats[beat.Index];
    var beatCursorWidth = 3;
    barCursor.css({
                  top: barBoundings.VisualBounds.Y + 'px',
                  left: barBoundings.VisualBounds.X + 'px',
                  width: barBoundings.VisualBounds.W + 'px',
                  height: barBoundings.VisualBounds.H + 'px'
                  });
    beatCursor.css({
                   top: beatBoundings.VisualBounds.Y + 'px',
                   left: beatBoundings.VisualBounds.X + 'px',
                   width: beatCursorWidth + 'px',
                   height: beatBoundings.VisualBounds.H + 'px'
                   });
    
    //if(context.cursorOptions.autoScroll == 'vertical') {
        var padding = beatCursor.offset().top - beatBoundings.VisualBounds.Y;
        var scrollTop = padding + beatBoundings.Bounds.Y + scrollOffset;
        if(scrollTop != lastScroll) {
            lastScroll = scrollTop;
            $('body,html').animate({
                       scrollTop:scrollTop + 'px'
               }, scrollSpeed);
               if (typeof android !== "undefined") {
                    android.SrcollTo(scrollTop);
               }
        }
        /*
    }
    else if(context.cursorOptions.autoScroll == 'horizontal-bar') {
        var padding = beatCursor.offset().left - beatBoundings.VisualBounds.X;
        if(barBoundings.VisualBounds.X != context.cursorOptions.lastScroll) {
            var scrollLeft = padding + beatBoundings.Bounds.X + context.cursorOptions.scrollOffset;
            context.cursorOptions.lastScroll = barBoundings.VisualBounds.X;
            $(context.cursorOptions.scrollElement).animate({
                                                           scrollLeft:scrollLeft + 'px'
                                                           }, context.cursorOptions.scrollSpeed);
        }
    }
    else if(context.cursorOptions.autoScroll == 'horizontal-offscreen') {
        var padding = beatCursor.offset().left - beatBoundings.VisualBounds.X;
        var elementRight = $(context.cursorOptions.scrollElement).scrollLeft() +
        $(context.cursorOptions.scrollElement).width();
        if( (barBoundings.VisualBounds.X + barBoundings.VisualBounds.W) >= elementRight ||
           barBoundings.VisualBounds.X < $(context.cursorOptions.scrollElement).scrollLeft()
           ) {
            var scrollLeft = padding + beatBoundings.Bounds.X + context.cursorOptions.scrollOffset;
            context.cursorOptions.lastScroll = barBoundings.VisualBounds.X;
            $(context.cursorOptions.scrollElement).animate({
                                                           scrollLeft:scrollLeft + 'px'
                                                           }, context.cursorOptions.scrollSpeed);
        }
    }
    */
}



var cursorCache = null;
function getBeatAtPos(x, y) {
    if(cursorCache == null) {
        var c = updateBoundingCache();
        cursorCache = c;
    }
    
    return cursorCache.GetBeatAtPos(x, y);
}

$(document).ready(function() {
   
//    settings.Engine = "canvas";
    settings.Width = $(window).width();
	settings.Scale = 0.6;
    $('#alphaTab').on('loaded', function(e, score) {
        currentScore = score;
        if (currentScore == null) {
            currentScore = $('div#alphaTab').data().alphaTab.Score;
        }
    });
   
    $('#alphaTab').alphaTab(settings);
//    $('#alphaTab').data('file', null);
                  
    // Create cursors

    var cursorWrapper = $('<div class="cursors"></div>');
    barCursor = $('<div class="barCursor"></div>');
    beatCursor = $('<div class="beatCursor"></div>');

    var element = $('#alphaTab');
    var surface = $('.alphaTabSurface', element);
//     required css styles
    element.css({position: 'relative'});
    element.css({'text-align': 'left'});

    cursorWrapper.css({position: 'absolute', "z-index": 1000, display: 'inline', 'pointer-events': 'none'});
    barCursor.css({position: 'absolute'});
    beatCursor.css({position: 'absolute'});

    // store options and created elements for fast access
    //context.cursorOptions.cursors = cursorWrapper;
    //context.cursorOptions.barCursor = barCursor;
    //context.cursorOptions.beatCursor = beatCursor;

    // add cursors to UI
    element.prepend(cursorWrapper);
    cursorWrapper.prepend(barCursor);
    cursorWrapper.prepend(beatCursor);
                  
    var context = element.data('alphaTab');
    $(context.CanvasElement).click(function(e) {
         var parentOffset = $(this).offset();
         var relX = e.pageX - parentOffset.left;
         var relY = e.pageY - parentOffset.top;
         var beat = getBeatAtPos(relX, relY);
         playerCursorUpdateBeat(beat, cursorCache);
         
         var masterBar = beat.Voice.Bar.get_MasterBar();
         var tickCache = getTickUpdateCache();
         var realMasterBarStart = tickCache.GetMasterBarStart(masterBar);
         if (typeof android !== "undefined") {
             android.SeekToMillis(TicksToMillis(realMasterBarStart + beat.Start));
         } else if (typeof window.webkit !== "undefined") {
             window.webkit.messageHandlers.at.postMessage(TicksToMillis(realMasterBarStart + beat.Start));
         }
         //as.SetPositionTick(realMasterBarStart + beat.Start);
    }); 
                  
    element.on('post-rendered', function(e, score) {
             cursorCache = updateBoundingCache();
           if (currentBeat != null) {
               playerCursorUpdateBeat(currentBeat, cursorCache);
           }
             cursorWrapper.css({position: 'absolute', "z-index": 1000,
                               width: surface.width(), height: surface.height()});
                         });
   
    var endsWith = function(s, suffix) {
        return s.indexOf(suffix, this.length - suffix.length) !== -1;
    };
   
    /* file reader */
    /*
    if (window.File && window.FileReader && window.FileList && window.Blob) {
        $('#openFileData').change(function(e) {
            var file = e.target.files[0];
            if(endsWith(file.name, "gp3") || endsWith(file.name, "gp4") || endsWith(file.name, "gp5") || endsWith(file.name, "gpx")) {
               
                var reader = new FileReader();
                reader.onload = function(e) {
                    openFile(e.target.result);
                };
                reader.readAsArrayBuffer(file)
           }
           else {
               //alert('Please open a Guitar Pro 3-6 File');
               $.post("/error", {"reason": "not a valid guitar pro file extension."}, "json");
           }
        });
    } 
    else {
//      $('#openFile').hide();
    }
    */
    /* Track Chooser */
//    $('#tracks').click(function(e) { e.preventDefault(); initializeTrackChooser(); $('#trackChooser').fadeIn(); });
//    $('#trackChooser .shadow').click(function() { $('#trackChooser').fadeOut(); } );
    window.webkit.messageHandlers.didload.postMessage(true);
});